Merge branch 'jc/calloc-fix'
[git] / t / test-lib.sh
1 # Test framework for git.  See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # Test the binaries we have just built.  The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22         # We allow tests to override this, in case they want to run tests
23         # outside of t/, e.g. for running tests on the test library
24         # itself.
25         TEST_DIRECTORY=$(pwd)
26 else
27         # ensure that TEST_DIRECTORY is an absolute path so that it
28         # is valid even if the current working directory is changed
29         TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
30 fi
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33         # Similarly, override this to store the test-results subdir
34         # elsewhere
35         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 fi
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
45 export ASAN_OPTIONS
46
47 # If LSAN is in effect we _do_ want leak checking, but we still
48 # want to abort so that we notice the problems.
49 : ${LSAN_OPTIONS=abort_on_error=1}
50 export LSAN_OPTIONS
51
52 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
53 then
54         echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
55         exit 1
56 fi
57 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58 export PERL_PATH SHELL_PATH
59
60 # Disallow the use of abbreviated options in the test suite by default
61 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
62 then
63         GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
64         export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
65 fi
66
67 ################################################################
68 # It appears that people try to run tests without building...
69 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
70 if test $? != 1
71 then
72         if test -n "$GIT_TEST_INSTALLED"
73         then
74                 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
75         else
76                 echo >&2 'error: you do not seem to have built git yet.'
77         fi
78         exit 1
79 fi
80
81 store_arg_to=
82 opt_required_arg=
83 # $1: option string
84 # $2: name of the var where the arg will be stored
85 mark_option_requires_arg () {
86         if test -n "$opt_required_arg"
87         then
88                 echo "error: options that require args cannot be bundled" \
89                         "together: '$opt_required_arg' and '$1'" >&2
90                 exit 1
91         fi
92         opt_required_arg=$1
93         store_arg_to=$2
94 }
95
96 parse_option () {
97         local opt="$1"
98
99         case "$opt" in
100         -d|--d|--de|--deb|--debu|--debug)
101                 debug=t ;;
102         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
103                 immediate=t ;;
104         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
105                 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
106         -r)
107                 mark_option_requires_arg "$opt" run_list
108                 ;;
109         --run=*)
110                 run_list=${opt#--*=} ;;
111         -h|--h|--he|--hel|--help)
112                 help=t ;;
113         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
114                 verbose=t ;;
115         --verbose-only=*)
116                 verbose_only=${opt#--*=}
117                 ;;
118         -q|--q|--qu|--qui|--quie|--quiet)
119                 # Ignore --quiet under a TAP::Harness. Saying how many tests
120                 # passed without the ok/not ok details is always an error.
121                 test -z "$HARNESS_ACTIVE" && quiet=t ;;
122         --with-dashes)
123                 with_dashes=t ;;
124         --no-bin-wrappers)
125                 no_bin_wrappers=t ;;
126         --no-color)
127                 color= ;;
128         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
129                 valgrind=memcheck
130                 tee=t
131                 ;;
132         --valgrind=*)
133                 valgrind=${opt#--*=}
134                 tee=t
135                 ;;
136         --valgrind-only=*)
137                 valgrind_only=${opt#--*=}
138                 tee=t
139                 ;;
140         --tee)
141                 tee=t ;;
142         --root=*)
143                 root=${opt#--*=} ;;
144         --chain-lint)
145                 GIT_TEST_CHAIN_LINT=1 ;;
146         --no-chain-lint)
147                 GIT_TEST_CHAIN_LINT=0 ;;
148         -x)
149                 trace=t ;;
150         -V|--verbose-log)
151                 verbose_log=t
152                 tee=t
153                 ;;
154         --write-junit-xml)
155                 write_junit_xml=t
156                 ;;
157         --stress)
158                 stress=t ;;
159         --stress=*)
160                 echo "error: --stress does not accept an argument: '$opt'" >&2
161                 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
162                 exit 1
163                 ;;
164         --stress-jobs=*)
165                 stress=t;
166                 stress_jobs=${opt#--*=}
167                 case "$stress_jobs" in
168                 *[!0-9]*|0*|"")
169                         echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
170                         exit 1
171                         ;;
172                 *)      # Good.
173                         ;;
174                 esac
175                 ;;
176         --stress-limit=*)
177                 stress=t;
178                 stress_limit=${opt#--*=}
179                 case "$stress_limit" in
180                 *[!0-9]*|0*|"")
181                         echo "error: --stress-limit=<N> requires the number of repetitions" >&2
182                         exit 1
183                         ;;
184                 *)      # Good.
185                         ;;
186                 esac
187                 ;;
188         *)
189                 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
190         esac
191 }
192
193 # Parse options while taking care to leave $@ intact, so we will still
194 # have all the original command line options when executing the test
195 # script again for '--tee' and '--verbose-log' later.
196 for opt
197 do
198         if test -n "$store_arg_to"
199         then
200                 eval $store_arg_to=\$opt
201                 store_arg_to=
202                 opt_required_arg=
203                 continue
204         fi
205
206         case "$opt" in
207         --*|-?)
208                 parse_option "$opt" ;;
209         -?*)
210                 # bundled short options must be fed separately to parse_option
211                 opt=${opt#-}
212                 while test -n "$opt"
213                 do
214                         extra=${opt#?}
215                         this=${opt%$extra}
216                         opt=$extra
217                         parse_option "-$this"
218                 done
219                 ;;
220         *)
221                 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
222         esac
223 done
224 if test -n "$store_arg_to"
225 then
226         echo "error: $opt_required_arg requires an argument" >&2
227         exit 1
228 fi
229
230 if test -n "$valgrind_only"
231 then
232         test -z "$valgrind" && valgrind=memcheck
233         test -z "$verbose" && verbose_only="$valgrind_only"
234 elif test -n "$valgrind"
235 then
236         test -z "$verbose_log" && verbose=t
237 fi
238
239 if test -n "$stress"
240 then
241         verbose=t
242         trace=t
243         immediate=t
244 fi
245
246 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
247 TEST_NAME="$(basename "$0" .sh)"
248 TEST_NUMBER="${TEST_NAME%%-*}"
249 TEST_NUMBER="${TEST_NUMBER#t}"
250 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
251 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
252 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
253 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
254 case "$TRASH_DIRECTORY" in
255 /*) ;; # absolute path is good
256  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
257 esac
258
259 # If --stress was passed, run this test repeatedly in several parallel loops.
260 if test "$GIT_TEST_STRESS_STARTED" = "done"
261 then
262         : # Don't stress test again.
263 elif test -n "$stress"
264 then
265         if test -n "$stress_jobs"
266         then
267                 job_count=$stress_jobs
268         elif test -n "$GIT_TEST_STRESS_LOAD"
269         then
270                 job_count="$GIT_TEST_STRESS_LOAD"
271         elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
272              test -n "$job_count"
273         then
274                 job_count=$((2 * $job_count))
275         else
276                 job_count=8
277         fi
278
279         mkdir -p "$TEST_RESULTS_DIR"
280         stressfail="$TEST_RESULTS_BASE.stress-failed"
281         rm -f "$stressfail"
282
283         stress_exit=0
284         trap '
285                 kill $job_pids 2>/dev/null
286                 wait
287                 stress_exit=1
288         ' TERM INT HUP
289
290         job_pids=
291         job_nr=0
292         while test $job_nr -lt "$job_count"
293         do
294                 (
295                         GIT_TEST_STRESS_STARTED=done
296                         GIT_TEST_STRESS_JOB_NR=$job_nr
297                         export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
298
299                         trap '
300                                 kill $test_pid 2>/dev/null
301                                 wait
302                                 exit 1
303                         ' TERM INT
304
305                         cnt=1
306                         while ! test -e "$stressfail" &&
307                               { test -z "$stress_limit" ||
308                                 test $cnt -le $stress_limit ; }
309                         do
310                                 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
311                                 test_pid=$!
312
313                                 if wait $test_pid
314                                 then
315                                         printf "OK   %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
316                                 else
317                                         echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
318                                         printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
319                                 fi
320                                 cnt=$(($cnt + 1))
321                         done
322                 ) &
323                 job_pids="$job_pids $!"
324                 job_nr=$(($job_nr + 1))
325         done
326
327         wait
328
329         if test -f "$stressfail"
330         then
331                 stress_exit=1
332                 echo "Log(s) of failed test run(s):"
333                 for failed_job_nr in $(sort -n "$stressfail")
334                 do
335                         echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
336                         cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
337                 done
338                 rm -rf "$TRASH_DIRECTORY.stress-failed"
339                 # Move the last one.
340                 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
341         fi
342
343         exit $stress_exit
344 fi
345
346 # if --tee was passed, write the output not only to the terminal, but
347 # additionally to the file test-results/$BASENAME.out, too.
348 if test "$GIT_TEST_TEE_STARTED" = "done"
349 then
350         : # do not redirect again
351 elif test -n "$tee"
352 then
353         mkdir -p "$TEST_RESULTS_DIR"
354
355         # Make this filename available to the sub-process in case it is using
356         # --verbose-log.
357         GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
358         export GIT_TEST_TEE_OUTPUT_FILE
359
360         # Truncate before calling "tee -a" to get rid of the results
361         # from any previous runs.
362         >"$GIT_TEST_TEE_OUTPUT_FILE"
363
364         (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
365          echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
366         test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
367         exit
368 fi
369
370 if test -n "$trace" && test -n "$test_untraceable"
371 then
372         # '-x' tracing requested, but this test script can't be reliably
373         # traced, unless it is run with a Bash version supporting
374         # BASH_XTRACEFD (introduced in Bash v4.1).
375         #
376         # Perform this version check _after_ the test script was
377         # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
378         # '--verbose-log', so the right shell is checked and the
379         # warning is issued only once.
380         if test -n "$BASH_VERSION" && eval '
381              test ${BASH_VERSINFO[0]} -gt 4 || {
382                test ${BASH_VERSINFO[0]} -eq 4 &&
383                test ${BASH_VERSINFO[1]} -ge 1
384              }
385            '
386         then
387                 : Executed by a Bash version supporting BASH_XTRACEFD.  Good.
388         else
389                 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
390                 trace=
391         fi
392 fi
393 if test -n "$trace" && test -z "$verbose_log"
394 then
395         verbose=t
396 fi
397
398 # For repeatability, reset the environment to known value.
399 # TERM is sanitized below, after saving color control sequences.
400 LANG=C
401 LC_ALL=C
402 PAGER=cat
403 TZ=UTC
404 export LANG LC_ALL PAGER TZ
405 EDITOR=:
406
407 # A call to "unset" with no arguments causes at least Solaris 10
408 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
409 # deriving from the command substitution clustered with the other
410 # ones.
411 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
412         my @env = keys %ENV;
413         my $ok = join("|", qw(
414                 TRACE
415                 DEBUG
416                 TEST
417                 .*_TEST
418                 PROVE
419                 VALGRIND
420                 UNZIP
421                 PERF_
422                 CURL_VERBOSE
423                 TRACE_CURL
424         ));
425         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
426         print join("\n", @vars);
427 ')
428 unset XDG_CACHE_HOME
429 unset XDG_CONFIG_HOME
430 unset GITPERLLIB
431 TEST_AUTHOR_LOCALNAME=author
432 TEST_AUTHOR_DOMAIN=example.com
433 GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
434 GIT_AUTHOR_NAME='A U Thor'
435 GIT_AUTHOR_DATE='1112354055 +0200'
436 TEST_COMMITTER_LOCALNAME=committer
437 TEST_COMMITTER_DOMAIN=example.com
438 GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
439 GIT_COMMITTER_NAME='C O Mitter'
440 GIT_COMMITTER_DATE='1112354055 +0200'
441 GIT_MERGE_VERBOSITY=5
442 GIT_MERGE_AUTOEDIT=no
443 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
444 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
445 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
446 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
447 export EDITOR
448
449 GIT_DEFAULT_HASH="${GIT_TEST_DEFAULT_HASH:-sha1}"
450 export GIT_DEFAULT_HASH
451
452 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
453 GIT_TRACE_BARE=1
454 export GIT_TRACE_BARE
455
456 # Use specific version of the index file format
457 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
458 then
459         GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
460         export GIT_INDEX_VERSION
461 fi
462
463 if test -n "$GIT_TEST_PERL_FATAL_WARNINGS"
464 then
465         GIT_PERL_FATAL_WARNINGS=1
466         export GIT_PERL_FATAL_WARNINGS
467 fi
468
469 # Add libc MALLOC and MALLOC_PERTURB test
470 # only if we are not executing the test with valgrind
471 if test -n "$valgrind" ||
472    test -n "$TEST_NO_MALLOC_CHECK"
473 then
474         setup_malloc_check () {
475                 : nothing
476         }
477         teardown_malloc_check () {
478                 : nothing
479         }
480 else
481         setup_malloc_check () {
482                 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
483                 export MALLOC_CHECK_ MALLOC_PERTURB_
484         }
485         teardown_malloc_check () {
486                 unset MALLOC_CHECK_ MALLOC_PERTURB_
487         }
488 fi
489
490 # Protect ourselves from common misconfiguration to export
491 # CDPATH into the environment
492 unset CDPATH
493
494 unset GREP_OPTIONS
495 unset UNZIP
496
497 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
498 1|2|true)
499         GIT_TRACE=4
500         ;;
501 esac
502
503 # Line feed
504 LF='
505 '
506
507 # Single quote
508 SQ=\'
509
510 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
511 # when case-folding filenames
512 u200c=$(printf '\342\200\214')
513
514 export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
515
516 # Each test should start with something like this, after copyright notices:
517 #
518 # test_description='Description of this test...
519 # This test checks if command xyzzy does the right thing...
520 # '
521 # . ./test-lib.sh
522 test "x$TERM" != "xdumb" && (
523                 test -t 1 &&
524                 tput bold >/dev/null 2>&1 &&
525                 tput setaf 1 >/dev/null 2>&1 &&
526                 tput sgr0 >/dev/null 2>&1
527         ) &&
528         color=t
529
530 if test -n "$color"
531 then
532         # Save the color control sequences now rather than run tput
533         # each time say_color() is called.  This is done for two
534         # reasons:
535         #   * TERM will be changed to dumb
536         #   * HOME will be changed to a temporary directory and tput
537         #     might need to read ~/.terminfo from the original HOME
538         #     directory to get the control sequences
539         # Note:  This approach assumes the control sequences don't end
540         # in a newline for any terminal of interest (command
541         # substitutions strip trailing newlines).  Given that most
542         # (all?) terminals in common use are related to ECMA-48, this
543         # shouldn't be a problem.
544         say_color_error=$(tput bold; tput setaf 1) # bold red
545         say_color_skip=$(tput setaf 4) # blue
546         say_color_warn=$(tput setaf 3) # brown/yellow
547         say_color_pass=$(tput setaf 2) # green
548         say_color_info=$(tput setaf 6) # cyan
549         say_color_reset=$(tput sgr0)
550         say_color_="" # no formatting for normal text
551         say_color () {
552                 test -z "$1" && test -n "$quiet" && return
553                 eval "say_color_color=\$say_color_$1"
554                 shift
555                 printf "%s\\n" "$say_color_color$*$say_color_reset"
556         }
557 else
558         say_color() {
559                 test -z "$1" && test -n "$quiet" && return
560                 shift
561                 printf "%s\n" "$*"
562         }
563 fi
564
565 TERM=dumb
566 export TERM
567
568 error () {
569         say_color error "error: $*"
570         finalize_junit_xml
571         GIT_EXIT_OK=t
572         exit 1
573 }
574
575 BUG () {
576         error >&7 "bug in the test script: $*"
577 }
578
579 say () {
580         say_color info "$*"
581 }
582
583 if test -n "$HARNESS_ACTIVE"
584 then
585         if test "$verbose" = t || test -n "$verbose_only"
586         then
587                 printf 'Bail out! %s\n' \
588                  'verbose mode forbidden under TAP harness; try --verbose-log'
589                 exit 1
590         fi
591 fi
592
593 test "${test_description}" != "" ||
594 error "Test script did not set test_description."
595
596 if test "$help" = "t"
597 then
598         printf '%s\n' "$test_description"
599         exit 0
600 fi
601
602 exec 5>&1
603 exec 6<&0
604 exec 7>&2
605 if test "$verbose_log" = "t"
606 then
607         exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
608 elif test "$verbose" = "t"
609 then
610         exec 4>&2 3>&1
611 else
612         exec 4>/dev/null 3>/dev/null
613 fi
614
615 # Send any "-x" output directly to stderr to avoid polluting tests
616 # which capture stderr. We can do this unconditionally since it
617 # has no effect if tracing isn't turned on.
618 #
619 # Note that this sets up the trace fd as soon as we assign the variable, so it
620 # must come after the creation of descriptor 4 above. Likewise, we must never
621 # unset this, as it has the side effect of closing descriptor 4, which we
622 # use to show verbose tests to the user.
623 #
624 # Note also that we don't need or want to export it. The tracing is local to
625 # this shell, and we would not want to influence any shells we exec.
626 BASH_XTRACEFD=4
627
628 test_failure=0
629 test_count=0
630 test_fixed=0
631 test_broken=0
632 test_success=0
633
634 test_external_has_tap=0
635
636 die () {
637         code=$?
638         # This is responsible for running the atexit commands even when a
639         # test script run with '--immediate' fails, or when the user hits
640         # ctrl-C, i.e. when 'test_done' is not invoked at all.
641         test_atexit_handler || code=$?
642         if test -n "$GIT_EXIT_OK"
643         then
644                 exit $code
645         else
646                 echo >&5 "FATAL: Unexpected exit with code $code"
647                 exit 1
648         fi
649 }
650
651 GIT_EXIT_OK=
652 trap 'die' EXIT
653 # Disable '-x' tracing, because with some shells, notably dash, it
654 # prevents running the cleanup commands when a test script run with
655 # '--verbose-log -x' is interrupted.
656 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
657
658 # The user-facing functions are loaded from a separate file so that
659 # test_perf subshells can have them too
660 . "$TEST_DIRECTORY/test-lib-functions.sh"
661
662 # You are not expected to call test_ok_ and test_failure_ directly, use
663 # the test_expect_* functions instead.
664
665 test_ok_ () {
666         if test -n "$write_junit_xml"
667         then
668                 write_junit_xml_testcase "$*"
669         fi
670         test_success=$(($test_success + 1))
671         say_color "" "ok $test_count - $@"
672 }
673
674 test_failure_ () {
675         if test -n "$write_junit_xml"
676         then
677                 junit_insert="<failure message=\"not ok $test_count -"
678                 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
679                 junit_insert="$junit_insert $(xml_attr_encode \
680                         "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
681                            then
682                                 test-tool path-utils skip-n-bytes \
683                                         "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
684                            else
685                                 printf '%s\n' "$@" | sed 1d
686                            fi)")"
687                 junit_insert="$junit_insert</failure>"
688                 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
689                 then
690                         junit_insert="$junit_insert<system-err>$(xml_attr_encode \
691                                 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
692                 fi
693                 write_junit_xml_testcase "$1" "      $junit_insert"
694         fi
695         test_failure=$(($test_failure + 1))
696         say_color error "not ok $test_count - $1"
697         shift
698         printf '%s\n' "$*" | sed -e 's/^/#      /'
699         test "$immediate" = "" || { finalize_junit_xml; GIT_EXIT_OK=t; exit 1; }
700 }
701
702 test_known_broken_ok_ () {
703         if test -n "$write_junit_xml"
704         then
705                 write_junit_xml_testcase "$* (breakage fixed)"
706         fi
707         test_fixed=$(($test_fixed+1))
708         say_color error "ok $test_count - $@ # TODO known breakage vanished"
709 }
710
711 test_known_broken_failure_ () {
712         if test -n "$write_junit_xml"
713         then
714                 write_junit_xml_testcase "$* (known breakage)"
715         fi
716         test_broken=$(($test_broken+1))
717         say_color warn "not ok $test_count - $@ # TODO known breakage"
718 }
719
720 test_debug () {
721         test "$debug" = "" || eval "$1"
722 }
723
724 match_pattern_list () {
725         arg="$1"
726         shift
727         test -z "$*" && return 1
728         for pattern_
729         do
730                 case "$arg" in
731                 $pattern_)
732                         return 0
733                 esac
734         done
735         return 1
736 }
737
738 match_test_selector_list () {
739         operation="$1"
740         shift
741         title="$1"
742         shift
743         arg="$1"
744         shift
745         test -z "$1" && return 0
746
747         # Commas are accepted as separators.
748         OLDIFS=$IFS
749         IFS=','
750         set -- $1
751         IFS=$OLDIFS
752
753         # If the first selector is negative we include by default.
754         include=
755         case "$1" in
756                 !*) include=t ;;
757         esac
758
759         for selector
760         do
761                 orig_selector=$selector
762
763                 positive=t
764                 case "$selector" in
765                         !*)
766                                 positive=
767                                 selector=${selector##?}
768                                 ;;
769                 esac
770
771                 test -z "$selector" && continue
772
773                 case "$selector" in
774                         *-*)
775                                 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
776                                 then
777                                         echo "error: $operation: invalid non-numeric in range" \
778                                                 "start: '$orig_selector'" >&2
779                                         exit 1
780                                 fi
781                                 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
782                                 then
783                                         echo "error: $operation: invalid non-numeric in range" \
784                                                 "end: '$orig_selector'" >&2
785                                         exit 1
786                                 fi
787                                 ;;
788                         *)
789                                 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
790                                 then
791                                         case "$title" in *${selector}*)
792                                                 include=$positive
793                                                 ;;
794                                         esac
795                                         continue
796                                 fi
797                 esac
798
799                 # Short cut for "obvious" cases
800                 test -z "$include" && test -z "$positive" && continue
801                 test -n "$include" && test -n "$positive" && continue
802
803                 case "$selector" in
804                         -*)
805                                 if test $arg -le ${selector#-}
806                                 then
807                                         include=$positive
808                                 fi
809                                 ;;
810                         *-)
811                                 if test $arg -ge ${selector%-}
812                                 then
813                                         include=$positive
814                                 fi
815                                 ;;
816                         *-*)
817                                 if test ${selector%%-*} -le $arg \
818                                         && test $arg -le ${selector#*-}
819                                 then
820                                         include=$positive
821                                 fi
822                                 ;;
823                         *)
824                                 if test $arg -eq $selector
825                                 then
826                                         include=$positive
827                                 fi
828                                 ;;
829                 esac
830         done
831
832         test -n "$include"
833 }
834
835 maybe_teardown_verbose () {
836         test -z "$verbose_only" && return
837         exec 4>/dev/null 3>/dev/null
838         verbose=
839 }
840
841 last_verbose=t
842 maybe_setup_verbose () {
843         test -z "$verbose_only" && return
844         if match_pattern_list $test_count $verbose_only
845         then
846                 exec 4>&2 3>&1
847                 # Emit a delimiting blank line when going from
848                 # non-verbose to verbose.  Within verbose mode the
849                 # delimiter is printed by test_expect_*.  The choice
850                 # of the initial $last_verbose is such that before
851                 # test 1, we do not print it.
852                 test -z "$last_verbose" && echo >&3 ""
853                 verbose=t
854         else
855                 exec 4>/dev/null 3>/dev/null
856                 verbose=
857         fi
858         last_verbose=$verbose
859 }
860
861 maybe_teardown_valgrind () {
862         test -z "$GIT_VALGRIND" && return
863         GIT_VALGRIND_ENABLED=
864 }
865
866 maybe_setup_valgrind () {
867         test -z "$GIT_VALGRIND" && return
868         if test -z "$valgrind_only"
869         then
870                 GIT_VALGRIND_ENABLED=t
871                 return
872         fi
873         GIT_VALGRIND_ENABLED=
874         if match_pattern_list $test_count $valgrind_only
875         then
876                 GIT_VALGRIND_ENABLED=t
877         fi
878 }
879
880 trace_level_=0
881 want_trace () {
882         test "$trace" = t && {
883                 test "$verbose" = t || test "$verbose_log" = t
884         }
885 }
886
887 # This is a separate function because some tests use
888 # "return" to end a test_expect_success block early
889 # (and we want to make sure we run any cleanup like
890 # "set +x").
891 test_eval_inner_ () {
892         # Do not add anything extra (including LF) after '$*'
893         eval "
894                 want_trace && trace_level_=$(($trace_level_+1)) && set -x
895                 $*"
896 }
897
898 test_eval_ () {
899         # If "-x" tracing is in effect, then we want to avoid polluting stderr
900         # with non-test commands. But once in "set -x" mode, we cannot prevent
901         # the shell from printing the "set +x" to turn it off (nor the saving
902         # of $? before that). But we can make sure that the output goes to
903         # /dev/null.
904         #
905         # There are a few subtleties here:
906         #
907         #   - we have to redirect descriptor 4 in addition to 2, to cover
908         #     BASH_XTRACEFD
909         #
910         #   - the actual eval has to come before the redirection block (since
911         #     it needs to see descriptor 4 to set up its stderr)
912         #
913         #   - likewise, any error message we print must be outside the block to
914         #     access descriptor 4
915         #
916         #   - checking $? has to come immediately after the eval, but it must
917         #     be _inside_ the block to avoid polluting the "set -x" output
918         #
919
920         test_eval_inner_ "$@" </dev/null >&3 2>&4
921         {
922                 test_eval_ret_=$?
923                 if want_trace
924                 then
925                         test 1 = $trace_level_ && set +x
926                         trace_level_=$(($trace_level_-1))
927                 fi
928         } 2>/dev/null 4>&2
929
930         if test "$test_eval_ret_" != 0 && want_trace
931         then
932                 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
933         fi
934         return $test_eval_ret_
935 }
936
937 test_run_ () {
938         test_cleanup=:
939         expecting_failure=$2
940
941         if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
942                 # turn off tracing for this test-eval, as it simply creates
943                 # confusing noise in the "-x" output
944                 trace_tmp=$trace
945                 trace=
946                 # 117 is magic because it is unlikely to match the exit
947                 # code of other programs
948                 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
949                         test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
950                 then
951                         BUG "broken &&-chain or run-away HERE-DOC: $1"
952                 fi
953                 trace=$trace_tmp
954         fi
955
956         setup_malloc_check
957         test_eval_ "$1"
958         eval_ret=$?
959         teardown_malloc_check
960
961         if test -z "$immediate" || test $eval_ret = 0 ||
962            test -n "$expecting_failure" && test "$test_cleanup" != ":"
963         then
964                 setup_malloc_check
965                 test_eval_ "$test_cleanup"
966                 teardown_malloc_check
967         fi
968         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
969         then
970                 echo ""
971         fi
972         return "$eval_ret"
973 }
974
975 test_start_ () {
976         test_count=$(($test_count+1))
977         maybe_setup_verbose
978         maybe_setup_valgrind
979         if test -n "$write_junit_xml"
980         then
981                 junit_start=$(test-tool date getnanos)
982         fi
983 }
984
985 test_finish_ () {
986         echo >&3 ""
987         maybe_teardown_valgrind
988         maybe_teardown_verbose
989         if test -n "$GIT_TEST_TEE_OFFSET"
990         then
991                 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
992                         "$GIT_TEST_TEE_OUTPUT_FILE")
993         fi
994 }
995
996 test_skip () {
997         to_skip=
998         skipped_reason=
999         if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
1000         then
1001                 to_skip=t
1002                 skipped_reason="GIT_SKIP_TESTS"
1003         fi
1004         if test -z "$to_skip" && test -n "$run_list" &&
1005            ! match_test_selector_list '--run' "$1" $test_count "$run_list"
1006         then
1007                 to_skip=t
1008                 skipped_reason="--run"
1009         fi
1010         if test -z "$to_skip" && test -n "$test_prereq" &&
1011            ! test_have_prereq "$test_prereq"
1012         then
1013                 to_skip=t
1014
1015                 of_prereq=
1016                 if test "$missing_prereq" != "$test_prereq"
1017                 then
1018                         of_prereq=" of $test_prereq"
1019                 fi
1020                 skipped_reason="missing $missing_prereq${of_prereq}"
1021         fi
1022
1023         case "$to_skip" in
1024         t)
1025                 if test -n "$write_junit_xml"
1026                 then
1027                         message="$(xml_attr_encode "$skipped_reason")"
1028                         write_junit_xml_testcase "$1" \
1029                                 "      <skipped message=\"$message\" />"
1030                 fi
1031
1032                 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1033                 : true
1034                 ;;
1035         *)
1036                 false
1037                 ;;
1038         esac
1039 }
1040
1041 # stub; perf-lib overrides it
1042 test_at_end_hook_ () {
1043         :
1044 }
1045
1046 write_junit_xml () {
1047         case "$1" in
1048         --truncate)
1049                 >"$junit_xml_path"
1050                 junit_have_testcase=
1051                 shift
1052                 ;;
1053         esac
1054         printf '%s\n' "$@" >>"$junit_xml_path"
1055 }
1056
1057 xml_attr_encode () {
1058         printf '%s\n' "$@" | test-tool xml-encode
1059 }
1060
1061 write_junit_xml_testcase () {
1062         junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1063         shift
1064         junit_attrs="$junit_attrs classname=\"$this_test\""
1065         junit_attrs="$junit_attrs time=\"$(test-tool \
1066                 date getnanos $junit_start)\""
1067         write_junit_xml "$(printf '%s\n' \
1068                 "    <testcase $junit_attrs>" "$@" "    </testcase>")"
1069         junit_have_testcase=t
1070 }
1071
1072 finalize_junit_xml () {
1073         if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1074         then
1075                 test -n "$junit_have_testcase" || {
1076                         junit_start=$(test-tool date getnanos)
1077                         write_junit_xml_testcase "all tests skipped"
1078                 }
1079
1080                 # adjust the overall time
1081                 junit_time=$(test-tool date getnanos $junit_suite_start)
1082                 sed -e "s/\(<testsuite.*\) time=\"[^\"]*\"/\1/" \
1083                         -e "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1084                         -e '/^ *<\/testsuite/d' \
1085                         <"$junit_xml_path" >"$junit_xml_path.new"
1086                 mv "$junit_xml_path.new" "$junit_xml_path"
1087
1088                 write_junit_xml "  </testsuite>" "</testsuites>"
1089                 write_junit_xml=
1090         fi
1091 }
1092
1093 test_atexit_cleanup=:
1094 test_atexit_handler () {
1095         # In a succeeding test script 'test_atexit_handler' is invoked
1096         # twice: first from 'test_done', then from 'die' in the trap on
1097         # EXIT.
1098         # This condition and resetting 'test_atexit_cleanup' below makes
1099         # sure that the registered cleanup commands are run only once.
1100         test : != "$test_atexit_cleanup" || return 0
1101
1102         setup_malloc_check
1103         test_eval_ "$test_atexit_cleanup"
1104         test_atexit_cleanup=:
1105         teardown_malloc_check
1106 }
1107
1108 test_done () {
1109         GIT_EXIT_OK=t
1110
1111         # Run the atexit commands _before_ the trash directory is
1112         # removed, so the commands can access pidfiles and socket files.
1113         test_atexit_handler
1114
1115         finalize_junit_xml
1116
1117         if test -z "$HARNESS_ACTIVE"
1118         then
1119                 mkdir -p "$TEST_RESULTS_DIR"
1120
1121                 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1122                 total $test_count
1123                 success $test_success
1124                 fixed $test_fixed
1125                 broken $test_broken
1126                 failed $test_failure
1127
1128                 EOF
1129         fi
1130
1131         if test "$test_fixed" != 0
1132         then
1133                 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1134         fi
1135         if test "$test_broken" != 0
1136         then
1137                 say_color warn "# still have $test_broken known breakage(s)"
1138         fi
1139         if test "$test_broken" != 0 || test "$test_fixed" != 0
1140         then
1141                 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1142                 msg="remaining $test_remaining test(s)"
1143         else
1144                 test_remaining=$test_count
1145                 msg="$test_count test(s)"
1146         fi
1147         case "$test_failure" in
1148         0)
1149                 if test $test_external_has_tap -eq 0
1150                 then
1151                         if test $test_remaining -gt 0
1152                         then
1153                                 say_color pass "# passed all $msg"
1154                         fi
1155
1156                         # Maybe print SKIP message
1157                         test -z "$skip_all" || skip_all="# SKIP $skip_all"
1158                         case "$test_count" in
1159                         0)
1160                                 say "1..$test_count${skip_all:+ $skip_all}"
1161                                 ;;
1162                         *)
1163                                 test -z "$skip_all" ||
1164                                 say_color warn "$skip_all"
1165                                 say "1..$test_count"
1166                                 ;;
1167                         esac
1168                 fi
1169
1170                 if test -z "$debug"
1171                 then
1172                         test -d "$TRASH_DIRECTORY" ||
1173                         error "Tests passed but trash directory already removed before test cleanup; aborting"
1174
1175                         cd "$TRASH_DIRECTORY/.." &&
1176                         rm -fr "$TRASH_DIRECTORY" || {
1177                                 # try again in a bit
1178                                 sleep 5;
1179                                 rm -fr "$TRASH_DIRECTORY"
1180                         } ||
1181                         error "Tests passed but test cleanup failed; aborting"
1182                 fi
1183                 test_at_end_hook_
1184
1185                 exit 0 ;;
1186
1187         *)
1188                 if test $test_external_has_tap -eq 0
1189                 then
1190                         say_color error "# failed $test_failure among $msg"
1191                         say "1..$test_count"
1192                 fi
1193
1194                 exit 1 ;;
1195
1196         esac
1197 }
1198
1199 if test -n "$valgrind"
1200 then
1201         make_symlink () {
1202                 test -h "$2" &&
1203                 test "$1" = "$(readlink "$2")" || {
1204                         # be super paranoid
1205                         if mkdir "$2".lock
1206                         then
1207                                 rm -f "$2" &&
1208                                 ln -s "$1" "$2" &&
1209                                 rm -r "$2".lock
1210                         else
1211                                 while test -d "$2".lock
1212                                 do
1213                                         say "Waiting for lock on $2."
1214                                         sleep 1
1215                                 done
1216                         fi
1217                 }
1218         }
1219
1220         make_valgrind_symlink () {
1221                 # handle only executables, unless they are shell libraries that
1222                 # need to be in the exec-path.
1223                 test -x "$1" ||
1224                 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1225                 return;
1226
1227                 base=$(basename "$1")
1228                 case "$base" in
1229                 test-*)
1230                         symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1231                         ;;
1232                 *)
1233                         symlink_target="$GIT_BUILD_DIR/$base"
1234                         ;;
1235                 esac
1236                 # do not override scripts
1237                 if test -x "$symlink_target" &&
1238                     test ! -d "$symlink_target" &&
1239                     test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1240                 then
1241                         symlink_target=../valgrind.sh
1242                 fi
1243                 case "$base" in
1244                 *.sh|*.perl)
1245                         symlink_target=../unprocessed-script
1246                 esac
1247                 # create the link, or replace it if it is out of date
1248                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1249         }
1250
1251         # override all git executables in TEST_DIRECTORY/..
1252         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1253         mkdir -p "$GIT_VALGRIND"/bin
1254         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1255         do
1256                 make_valgrind_symlink $file
1257         done
1258         # special-case the mergetools loadables
1259         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1260         OLDIFS=$IFS
1261         IFS=:
1262         for path in $PATH
1263         do
1264                 ls "$path"/git-* 2> /dev/null |
1265                 while read file
1266                 do
1267                         make_valgrind_symlink "$file"
1268                 done
1269         done
1270         IFS=$OLDIFS
1271         PATH=$GIT_VALGRIND/bin:$PATH
1272         GIT_EXEC_PATH=$GIT_VALGRIND/bin
1273         export GIT_VALGRIND
1274         GIT_VALGRIND_MODE="$valgrind"
1275         export GIT_VALGRIND_MODE
1276         GIT_VALGRIND_ENABLED=t
1277         test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1278         export GIT_VALGRIND_ENABLED
1279 elif test -n "$GIT_TEST_INSTALLED"
1280 then
1281         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
1282         error "Cannot run git from $GIT_TEST_INSTALLED."
1283         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1284         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1285 else # normal case, use ../bin-wrappers only unless $with_dashes:
1286         if test -n "$no_bin_wrappers"
1287         then
1288                 with_dashes=t
1289         else
1290                 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1291                 if ! test -x "$git_bin_dir/git"
1292                 then
1293                         if test -z "$with_dashes"
1294                         then
1295                                 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1296                         fi
1297                         with_dashes=t
1298                 fi
1299                 PATH="$git_bin_dir:$PATH"
1300         fi
1301         GIT_EXEC_PATH=$GIT_BUILD_DIR
1302         if test -n "$with_dashes"
1303         then
1304                 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1305         fi
1306 fi
1307 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1308 GIT_CONFIG_NOSYSTEM=1
1309 GIT_ATTR_NOSYSTEM=1
1310 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1311
1312 if test -z "$GIT_TEST_CMP"
1313 then
1314         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1315         then
1316                 GIT_TEST_CMP="$DIFF -c"
1317         else
1318                 GIT_TEST_CMP="$DIFF -u"
1319         fi
1320 fi
1321
1322 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1323 export GITPERLLIB
1324 test -d "$GIT_BUILD_DIR"/templates/blt || {
1325         error "You haven't built things yet, have you?"
1326 }
1327
1328 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1329 then
1330         echo >&2 'You need to build test-tool:'
1331         echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1332         exit 1
1333 fi
1334
1335 # Test repository
1336 rm -fr "$TRASH_DIRECTORY" || {
1337         GIT_EXIT_OK=t
1338         echo >&5 "FATAL: Cannot prepare test area"
1339         exit 1
1340 }
1341
1342 HOME="$TRASH_DIRECTORY"
1343 GNUPGHOME="$HOME/gnupg-home-not-used"
1344 export HOME GNUPGHOME
1345
1346 if test -z "$TEST_NO_CREATE_REPO"
1347 then
1348         test_create_repo "$TRASH_DIRECTORY"
1349 else
1350         mkdir -p "$TRASH_DIRECTORY"
1351 fi
1352
1353 # Use -P to resolve symlinks in our working directory so that the cwd
1354 # in subprocesses like git equals our $PWD (for pathname comparisons).
1355 cd -P "$TRASH_DIRECTORY" || exit 1
1356
1357 this_test=${0##*/}
1358 this_test=${this_test%%-*}
1359 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1360 then
1361         say_color info >&3 "skipping test $this_test altogether"
1362         skip_all="skip all tests in $this_test"
1363         test_done
1364 fi
1365
1366 if test -n "$write_junit_xml"
1367 then
1368         junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1369         mkdir -p "$junit_xml_dir"
1370         junit_xml_base=${0##*/}
1371         junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1372         junit_attrs="name=\"${junit_xml_base%.sh}\""
1373         junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1374                 date +%Y-%m-%dT%H:%M:%S)\""
1375         write_junit_xml --truncate "<testsuites>" "  <testsuite $junit_attrs>"
1376         junit_suite_start=$(test-tool date getnanos)
1377         if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1378         then
1379                 GIT_TEST_TEE_OFFSET=0
1380         fi
1381 fi
1382
1383 # Convenience
1384 # A regexp to match 5, 35 and 40 hexdigits
1385 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1386 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1387 _x40="$_x35$_x05"
1388
1389 test_oid_init
1390
1391 ZERO_OID=$(test_oid zero)
1392 OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1393 OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1394 EMPTY_TREE=$(test_oid empty_tree)
1395 EMPTY_BLOB=$(test_oid empty_blob)
1396 _z40=$ZERO_OID
1397
1398 # Provide an implementation of the 'yes' utility; the upper bound
1399 # limit is there to help Windows that cannot stop this loop from
1400 # wasting cycles when the downstream stops reading, so do not be
1401 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1402 # limit the output of the yes utility", 2016-02-02)
1403 yes () {
1404         if test $# = 0
1405         then
1406                 y=y
1407         else
1408                 y="$*"
1409         fi
1410
1411         i=0
1412         while test $i -lt 99
1413         do
1414                 echo "$y"
1415                 i=$(($i+1))
1416         done
1417 }
1418
1419 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1420 # thus needs to be set up really early, and set an internal variable
1421 # for convenience so the hot test_set_prereq() codepath doesn't need
1422 # to call "git env--helper" (via test_bool_env). Only do that work
1423 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1424 GIT_TEST_FAIL_PREREQS_INTERNAL=
1425 if test -n "$GIT_TEST_FAIL_PREREQS"
1426 then
1427         if test_bool_env GIT_TEST_FAIL_PREREQS false
1428         then
1429                 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1430                 test_set_prereq FAIL_PREREQS
1431         fi
1432 else
1433         test_lazy_prereq FAIL_PREREQS '
1434                 test_bool_env GIT_TEST_FAIL_PREREQS false
1435         '
1436 fi
1437
1438 # Fix some commands on Windows, and other OS-specific things
1439 uname_s=$(uname -s)
1440 case $uname_s in
1441 *MINGW*)
1442         # Windows has its own (incompatible) sort and find
1443         sort () {
1444                 /usr/bin/sort "$@"
1445         }
1446         find () {
1447                 /usr/bin/find "$@"
1448         }
1449         # git sees Windows-style pwd
1450         pwd () {
1451                 builtin pwd -W
1452         }
1453         # no POSIX permissions
1454         # backslashes in pathspec are converted to '/'
1455         # exec does not inherit the PID
1456         test_set_prereq MINGW
1457         test_set_prereq NATIVE_CRLF
1458         test_set_prereq SED_STRIPS_CR
1459         test_set_prereq GREP_STRIPS_CR
1460         GIT_TEST_CMP=mingw_test_cmp
1461         ;;
1462 *CYGWIN*)
1463         test_set_prereq POSIXPERM
1464         test_set_prereq EXECKEEPSPID
1465         test_set_prereq CYGWIN
1466         test_set_prereq SED_STRIPS_CR
1467         test_set_prereq GREP_STRIPS_CR
1468         ;;
1469 *)
1470         test_set_prereq POSIXPERM
1471         test_set_prereq BSLASHPSPEC
1472         test_set_prereq EXECKEEPSPID
1473         ;;
1474 esac
1475
1476 # Detect arches where a few things don't work
1477 uname_m=$(uname -m)
1478 case $uname_m in
1479 parisc* | hppa*)
1480         test_set_prereq HPPA
1481         ;;
1482 esac
1483
1484 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1485 test -z "$NO_PERL" && test_set_prereq PERL
1486 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1487 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1488 test -n "$USE_LIBPCRE2" && test_set_prereq PCRE
1489 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1490 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1491
1492 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1493 then
1494         GIT_TEST_CHECK_CACHE_TREE=true
1495         export GIT_TEST_CHECK_CACHE_TREE
1496 fi
1497
1498 test_lazy_prereq PIPE '
1499         # test whether the filesystem supports FIFOs
1500         test_have_prereq !MINGW,!CYGWIN &&
1501         rm -f testfifo && mkfifo testfifo
1502 '
1503
1504 test_lazy_prereq SYMLINKS '
1505         # test whether the filesystem supports symbolic links
1506         ln -s x y && test -h y
1507 '
1508
1509 test_lazy_prereq FILEMODE '
1510         test "$(git config --bool core.filemode)" = true
1511 '
1512
1513 test_lazy_prereq CASE_INSENSITIVE_FS '
1514         echo good >CamelCase &&
1515         echo bad >camelcase &&
1516         test "$(cat CamelCase)" != good
1517 '
1518
1519 test_lazy_prereq FUNNYNAMES '
1520         test_have_prereq !MINGW &&
1521         touch -- \
1522                 "FUNNYNAMES tab embedded" \
1523                 "FUNNYNAMES \"quote embedded\"" \
1524                 "FUNNYNAMES newline
1525 embedded" 2>/dev/null &&
1526         rm -- \
1527                 "FUNNYNAMES tab embedded" \
1528                 "FUNNYNAMES \"quote embedded\"" \
1529                 "FUNNYNAMES newline
1530 embedded" 2>/dev/null
1531 '
1532
1533 test_lazy_prereq UTF8_NFD_TO_NFC '
1534         # check whether FS converts nfd unicode to nfc
1535         auml=$(printf "\303\244")
1536         aumlcdiar=$(printf "\141\314\210")
1537         >"$auml" &&
1538         test -f "$aumlcdiar"
1539 '
1540
1541 test_lazy_prereq AUTOIDENT '
1542         sane_unset GIT_AUTHOR_NAME &&
1543         sane_unset GIT_AUTHOR_EMAIL &&
1544         git var GIT_AUTHOR_IDENT
1545 '
1546
1547 test_lazy_prereq EXPENSIVE '
1548         test -n "$GIT_TEST_LONG"
1549 '
1550
1551 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1552         test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1553 '
1554
1555 test_lazy_prereq USR_BIN_TIME '
1556         test -x /usr/bin/time
1557 '
1558
1559 test_lazy_prereq NOT_ROOT '
1560         uid=$(id -u) &&
1561         test "$uid" != 0
1562 '
1563
1564 test_lazy_prereq JGIT '
1565         jgit --version
1566 '
1567
1568 # SANITY is about "can you correctly predict what the filesystem would
1569 # do by only looking at the permission bits of the files and
1570 # directories?"  A typical example of !SANITY is running the test
1571 # suite as root, where a test may expect "chmod -r file && cat file"
1572 # to fail because file is supposed to be unreadable after a successful
1573 # chmod.  In an environment (i.e. combination of what filesystem is
1574 # being used and who is running the tests) that lacks SANITY, you may
1575 # be able to delete or create a file when the containing directory
1576 # doesn't have write permissions, or access a file even if the
1577 # containing directory doesn't have read or execute permissions.
1578
1579 test_lazy_prereq SANITY '
1580         mkdir SANETESTD.1 SANETESTD.2 &&
1581
1582         chmod +w SANETESTD.1 SANETESTD.2 &&
1583         >SANETESTD.1/x 2>SANETESTD.2/x &&
1584         chmod -w SANETESTD.1 &&
1585         chmod -r SANETESTD.1/x &&
1586         chmod -rx SANETESTD.2 ||
1587         BUG "cannot prepare SANETESTD"
1588
1589         ! test -r SANETESTD.1/x &&
1590         ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1591         status=$?
1592
1593         chmod +rwx SANETESTD.1 SANETESTD.2 &&
1594         rm -rf SANETESTD.1 SANETESTD.2 ||
1595         BUG "cannot clean SANETESTD"
1596         return $status
1597 '
1598
1599 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1600 GIT_UNZIP=${GIT_UNZIP:-unzip}
1601 test_lazy_prereq UNZIP '
1602         "$GIT_UNZIP" -v
1603         test $? -ne 127
1604 '
1605
1606 run_with_limited_cmdline () {
1607         (ulimit -s 128 && "$@")
1608 }
1609
1610 test_lazy_prereq CMDLINE_LIMIT '
1611         test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1612         run_with_limited_cmdline true
1613 '
1614
1615 run_with_limited_stack () {
1616         (ulimit -s 128 && "$@")
1617 }
1618
1619 test_lazy_prereq ULIMIT_STACK_SIZE '
1620         test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1621         run_with_limited_stack true
1622 '
1623
1624 run_with_limited_open_files () {
1625         (ulimit -n 32 && "$@")
1626 }
1627
1628 test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1629         test_have_prereq !MINGW,!CYGWIN &&
1630         run_with_limited_open_files true
1631 '
1632
1633 build_option () {
1634         git version --build-options |
1635         sed -ne "s/^$1: //p"
1636 }
1637
1638 test_lazy_prereq LONG_IS_64BIT '
1639         test 8 -le "$(build_option sizeof-long)"
1640 '
1641
1642 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1643 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1644
1645 test_lazy_prereq CURL '
1646         curl --version
1647 '
1648
1649 # SHA1 is a test if the hash algorithm in use is SHA-1.  This is both for tests
1650 # which will not work with other hash algorithms and tests that work but don't
1651 # test anything meaningful (e.g. special values which cause short collisions).
1652 test_lazy_prereq SHA1 '
1653         case "$GIT_DEFAULT_HASH" in
1654         sha1) true ;;
1655         "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1656         *) false ;;
1657         esac
1658 '
1659
1660 test_lazy_prereq REBASE_P '
1661         test -z "$GIT_TEST_SKIP_REBASE_P"
1662 '
1663
1664 # Ensure that no test accidentally triggers a Git command
1665 # that runs the actual maintenance scheduler, affecting a user's
1666 # system permanently.
1667 # Tests that verify the scheduler integration must set this locally
1668 # to avoid errors.
1669 GIT_TEST_MAINT_SCHEDULER="none:exit 1"